--- !ditz.rubyforge.org,2008-03-06/issue 
title: Consider adding a rendering type, and devising a rendering architecture.
desc: ""
type: :task
component: libale
release: 
reporter: David Hilvert <dhilvert@auricle.dyndns.org>
status: :closed
disposition: :fixed
creation_time: 2009-02-13 15:35:02.180347 Z
references: []

id: 42d527db18c8725459d44a1a49e0105bf6d1b5ff
log_events: 
- - 2009-02-13 15:35:02.925549 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - created
  - ""
- - 2009-02-13 15:44:03.303842 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    A design similar to that used in ALE might be considered, except perhaps that, rather than
    passing frame indices as arguments, a frame (image) and associated transformation might be
    passed instead, so that a renderer, after taking a sequence of such arguments, might then
    produce (upon demand) an output result.
    
    Irani-Peleg rendering might occur differently, taking a sequence all at once, or might
    follow the same pattern, perhaps with the same sort of explicit synchronization call
    found within the current ALE design.
- - 2009-02-13 16:01:32.284155 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Note that the problem of determining when returned data (approximations, or
    images) should be freed, which may also have arisen in the original ALE
    implementation, should be fairly straightforward to resolve through reference
    counting on images (which counters are already present in all libale types).
- - 2009-02-14 10:36:53.250556 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Note that the problem of returning images segmented by reference_size might be resolved
    through the use of renderers to convert images to use more compact formats and types; also,
    renderers could signal that multiple approximations (images) must be used to completely
    describe a rendering result, so that segmentation could occur in this way when necessary.
- - 2009-02-14 14:33:14.238523 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - commented
  - |-
    Consider that rendering invariants would probably be most appropriately set within the renderer
    type (as is done in ALE, as opposed to within the approximation type, as is currently done in libale).
    
    Note also that reference_size segmentation would probably most naturally be handled within the image
    (approximation) type, rather than within the renderer type, as has already been noted in {issue 76aa36a03fb8d5ab1fdfc54a23caeed859c97da1}.
- - 2009-02-16 18:09:42.623076 Z
  - David Hilvert <dhilvert@auricle.dyndns.org>
  - closed with disposition fixed
  - |-
    A type and skeletal architecture have been added.  Further development roughly
    according to the ALE architecture would probably be appropriate.
